import { BskHttpService } from './src/bsk-http.service';
import { IBskHttpService } from './src/definitions/Ibsk-http.service';
import { IStorageService } from './src/definitions/Istorage.service';
import { ILoggerService } from './src/definitions/Ilogger.service';
import { LoggerService } from './src/logger.service';

import { NgModule, ModuleWithProviders, Type } from '@angular/core';

export { ILoggerService } from './src/definitions/Ilogger.service';
export { LoggerService } from './src/logger.service';
export { IStorageService } from './src/definitions/Istorage.service';
export { IBskHttpService } from './src/definitions/Ibsk-http.service';


@NgModule({
  imports: [],
  exports: [],
  providers: [
    { provide: 'IBskHttpService', useClass: BskHttpService }
  ]
})
export class UtilitiesModule {

  public static forRoot(storageService: Type<IStorageService>, externalLogger?: Type<ILoggerService>): ModuleWithProviders {
    return {
      ngModule: UtilitiesModule,
      providers: [
        { provide: 'IStorageService', useClass: storageService },
        { provide: 'ILoggerService', useClass: externalLogger ? externalLogger : LoggerService }
      ]
    };
  }
}

