import { Headers, Http, Response } from '@angular/http';
import { Injectable, Inject } from '@angular/core';

import { Observable } from 'rxjs/Observable'
import 'rxjs/add/operator/switchMap';

import { IBskHttpService } from './definitions/Ibsk-http.service';
import { IStorageService } from './definitions/Istorage.service';

@Injectable()
export class BskHttpService implements IBskHttpService {
	constructor( @Inject('IStorageService') private storage: IStorageService, private httpService: Http) { }

	private testUrl = 'https://en.wikipedia.org/w/api.php?action=query&titles=Main%20Page&prop=revisions&rvprop=content&format=json';

	get(url: string): Observable<any> {
		return this.storage.get('sessionToken').switchMap(token => {
			return this.httpService.get(this.testUrl);
		}, error => this.handleTokenError(error));
	}

	private handleTokenError(error: any) {
		return Observable.throw('There was an error retrieving the token');
	}
}


